// Scope 2
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 2, binding = 0, std140) uniform _68_70
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
} _70;

layout(set = 1, binding = 0, std140) uniform _144_146
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
} _146;

layout(set = 0, binding = 1, std430) restrict readonly buffer _170_172
{
    vec4 _m0[];
} _172;

layout(set = 0, binding = 0, std140) uniform _416_418
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
} _418;

layout(set = 0, binding = 5, std430) restrict readonly buffer _999_1001
{
    uint _m0[];
} _1001;

layout(set = 0, binding = 6, std140) uniform _1004_1006
{
    vec4 _m0[4096];
} _1006;

layout(set = 0, binding = 7, std140) uniform _1008_1010
{
    vec4 _m0[4096];
} _1010;

layout(set = 0, binding = 8, std140) uniform _1012_1014
{
    vec4 _m0[4096];
} _1014;

layout(set = 0, binding = 10, std140) uniform _1020_1022
{
    vec4 _m0[4096];
} _1022;

layout(set = 0, binding = 11, std140) uniform _1024_1026
{
    vec4 _m0[4096];
} _1026;

layout(set = 0, binding = 12, std140) uniform _1028_1030
{
    vec4 _m0[4096];
} _1030;

layout(set = 0, binding = 15, std140) uniform _1037_1039
{
    vec4 _m0[4095];
} _1039;

layout(push_constant, std430) uniform _995_997
{
    int _m0;
    int _m1;
} _997;

layout(set = 0, binding = 2) uniform sampler3D _795;
layout(set = 0, binding = 3) uniform sampler3D _877;
layout(set = 0, binding = 9) uniform sampler2D _1018;
layout(set = 0, binding = 13) uniform samplerCubeArray _1034;
layout(set = 0, binding = 14) uniform sampler2D _1035;
layout(set = 0, binding = 16) uniform sampler2DShadow _1043;
layout(set = 0, binding = 17) uniform sampler2D _1044;
layout(set = 0, binding = 18) uniform sampler2D _1045;
layout(set = 0, binding = 19) uniform sampler3D _1046;
layout(set = 0, binding = 20) uniform sampler3D _1047;
layout(set = 0, binding = 21) uniform sampler3D _1048;
layout(set = 2, binding = 1) uniform sampler2D _1049;
layout(set = 2, binding = 2) uniform sampler2D _1050;
layout(set = 2, binding = 3) uniform sampler2D _1051;

layout(location = 0) in vec4 _60;
layout(location = 2) in vec4 _105;
layout(location = 9) in vec4 _112;
layout(location = 3) in vec4 _153;
layout(location = 3) out vec4 _496;
layout(location = 4) out vec4 _520;
layout(location = 5) out vec4 _543;
layout(location = 6) out vec4 _589;
layout(location = 1) in vec2 _598;
layout(location = 2) out vec4 _600;
layout(location = 12) in vec2 _619;
layout(location = 10) out vec4 _633;
layout(location = 11) out vec4 _634;
layout(location = 12) out vec4 _635;

float _22(vec4 _20, vec4 _21)
{
    return dot(_20, _21);
}

float _18(vec4 _16, vec4 _17)
{
    return dot(_16.xyz, _17.xyz);
}

mat4 _29(mat4 _27, mat4 _28)
{
    return _27 * _28;
}

vec3 _11(vec3 _10)
{
    return clamp(_10, vec3(0.0), vec3(1.0));
}

void main()
{
    vec4 _56 = vec4(0.0);
    vec3 _58 = _60.xyz;
    _56.x = (_58.x * _70._m0.x) + _70._m1.x;
    _56.y = (_58.y * _70._m0.y) + _70._m1.y;
    _56.z = (_58.z * _70._m0.z) + _70._m1.z;
    _56.w = 1.0;
    vec4 _104 = (_105 * 2.0) - vec4(1.0);
    vec4 _111 = (_112 * 2.0) - vec4(1.0);
    _111.w = (floor((_112.w * 255.100006103515625) / 128.0) * 2.0) - 1.0;
    float _128 = 0.0;
    if (_70._m2.z != 0.0)
    {
        vec4 _136 = _56;
        vec4 _138 = vec4(0.0);
        vec4 _139 = vec4(0.0);
        vec4 _140 = vec4(0.0);
        uvec4 _143 = uvec4(uint(_146._m0.x + _70._m2.x)) + uvec4(_153 * 255.0);
        if (_70._m2.z == 1.0)
        {
            uint _166 = _143.x;
            _138 = _172._m0[(_166 * 3u) + 0u];
            _139 = _172._m0[(_166 * 3u) + 1u];
            _140 = _172._m0[(_166 * 3u) + 2u];
        }
        else
        {
            float _190 = _112.w * 255.100006103515625;
            vec4 _194;
            _194.y = _190 - (floor(_190 / 128.0) * 128.0);
            float _202 = _105.w * 255.100006103515625;
            _194.z = floor(_202 / 16.0);
            _194.w = _202 - (_194.z * 16.0);
            _194.y *= 0.00393700785934925079345703125;
            _194.z *= 0.02222222276031970977783203125;
            _194.w *= 0.01666666753590106964111328125;
            _194.x = 1.0 - ((_194.y + _194.z) + _194.w);
            for (uint _242 = 0u; _242 < 4u; _242++)
            {
                _138 += (_172._m0[(_143[_242] * 3u) + 0u] * _194[_242]);
            }
            for (uint _266 = 0u; _266 < 4u; _266++)
            {
                _139 += (_172._m0[(_143[_266] * 3u) + 1u] * _194[_266]);
            }
            for (uint _289 = 0u; _289 < 4u; _289++)
            {
                _140 += (_172._m0[(_143[_289] * 3u) + 2u] * _194[_289]);
            }
        }
        vec4 _312 = _136;
        vec4 _314 = _138;
        _56.x = _22(_312, _314);
        vec4 _318 = _136;
        vec4 _320 = _139;
        _56.y = _22(_318, _320);
        vec4 _324 = _136;
        vec4 _326 = _140;
        _56.z = _22(_324, _326);
        _56.w = 1.0;
        vec4 _331 = _104;
        vec4 _333 = _331;
        vec4 _335 = _138;
        _104.x = _18(_333, _335);
        vec4 _339 = _331;
        vec4 _341 = _139;
        _104.y = _18(_339, _341);
        vec4 _345 = _331;
        vec4 _347 = _140;
        _104.z = _18(_345, _347);
        vec4 _351 = _111;
        vec4 _353 = _351;
        vec4 _355 = _138;
        _111.x = _18(_353, _355);
        vec4 _359 = _351;
        vec4 _361 = _139;
        _111.y = _18(_359, _361);
        vec4 _365 = _351;
        vec4 _367 = _140;
        _111.z = _18(_365, _367);
    }
    vec3 _379 = cross(_104.xyz, _111.xyz) * _111.w;
    vec4 _371;
    _371 = vec4(_379.x, _379.y, _379.z, _371.w);
    _371.w = 0.0;
    mat4 _383 = mat4(vec4(_146._m1), vec4(_146._m2), vec4(_146._m3), vec4(_146._m4));
    mat4 _415 = mat4(vec4(_418._m0), vec4(_418._m1), vec4(_418._m2), vec4(_418._m3));
    mat4 _449 = _383;
    mat4 _451 = _415;
    mat4 _448 = _29(_449, _451);
    vec4 _454 = _448[0];
    vec4 _457 = _448[1];
    vec4 _460 = _448[2];
    vec4 _463 = _448[3];
    vec4 _470 = _56;
    vec4 _472 = _454;
    gl_Position.x = _22(_470, _472);
    vec4 _477 = _56;
    vec4 _479 = _457;
    gl_Position.y = _22(_477, _479);
    vec4 _483 = _56;
    vec4 _485 = _460;
    gl_Position.z = _22(_483, _485);
    vec4 _489 = _56;
    vec4 _491 = _463;
    gl_Position.w = _22(_489, _491);
    vec4 _497 = _111;
    vec4 _499 = _146._m1;
    _496.x = _18(_497, _499);
    vec4 _504 = _371;
    vec4 _506 = _146._m1;
    _496.y = _18(_504, _506);
    vec4 _511 = _104;
    vec4 _513 = _146._m1;
    _496.z = _18(_511, _513);
    _496.w = _128;
    vec4 _521 = _111;
    vec4 _523 = _146._m2;
    _520.x = _18(_521, _523);
    vec4 _528 = _371;
    vec4 _530 = _146._m2;
    _520.y = _18(_528, _530);
    vec4 _535 = _104;
    vec4 _537 = _146._m2;
    _520.z = _18(_535, _537);
    _520.w = 0.0;
    vec4 _544 = _111;
    vec4 _546 = _146._m3;
    _543.x = _18(_544, _546);
    vec4 _551 = _371;
    vec4 _553 = _146._m3;
    _543.y = _18(_551, _553);
    vec4 _558 = _104;
    vec4 _560 = _146._m3;
    _543.z = _18(_558, _560);
    _543.w = 0.0;
    vec4 _567 = _56;
    vec4 _569 = _146._m1;
    vec4 _566;
    _566.x = _22(_567, _569);
    vec4 _574 = _56;
    vec4 _576 = _146._m2;
    _566.y = _22(_574, _576);
    vec4 _581 = _56;
    vec4 _583 = _146._m3;
    _566.z = _22(_581, _583);
    _566.w = 1.0;
    _589 = _566 - _418._m4;
    vec2 _596 = _598;
    _600.x = (_596.x * _70._m3.x) + _70._m3.z;
    _600.y = (_596.y * _70._m3.y) + _70._m3.w;
    _600.z = _619.x;
    _600.w = _619.y;
    vec3 _626 = _589.xyz + _418._m4.xyz;
    _633 = vec4(0.0);
    _634 = vec4(0.0);
    _635 = vec4(0.0);
    float _636 = float(_418._m5.x > 0.0);
    float _642 = _418._m5.x * _146._m5.x;
    bool _651 = _418._m5.y > 0.0;
    bool _658;
    if (!_651)
    {
        _658 = _418._m5.z > 0.0;
    }
    else
    {
        _658 = _651;
    }
    bool _665;
    if (!_658)
    {
        _665 = _418._m5.w > 0.0;
    }
    else
    {
        _665 = _658;
    }
    float _648 = float(_665);
    vec3 _667 = vec3(0.579999983310699462890625) * _418._m5.yzw;
    _633 = vec4(_418._m5.y, _418._m5.z, _418._m5.w, _667.x);
    _634 = vec4(_667.y, _667.z, _667.x, _667.y);
    _635 = vec4(_667.z, _667.x, _667.y, _667.z);
    if ((_636 > 0.0) && (_648 <= 0.0))
    {
        float _708 = -4096.0;
        float _710 = 4096.0;
        float _712 = 256.0;
        float _714 = 256.0;
        float _715 = 8.0;
        float _717 = 256.0;
        float _718 = 256.0;
        float _719 = 30.0;
        vec3 _721 = vec3(1.0 / _717, 1.0 / _718, 1.0 / _719);
        vec3 _729 = vec3(2.0 / _717, 2.0 / _718, 2.0 / _719);
        vec3 _737 = vec3(1.0 / _712, 1.0 / _714, 1.0 / _715);
        float _745 = 1.0 / (_710 - _708);
        vec3 _757 = (_626 - vec3(_708)) * _745;
        vec3 _750 = _11(_757);
        vec4 _759 = vec4(0.0);
        uvec3 _762 = uvec3(0u);
        for (uint _764 = 0u; _764 < 13u; _764++)
        {
            vec3 _773 = vec3(0.5) + floor(vec3(2.0) * _750);
            vec4 _781 = vec4(_737 * (vec3(_762) + _773), 0.0);
            _759 = textureLod(_795, _781.xyz, _781.w);
            _750 = fract(_750 * vec3(2.0));
            _762 = uvec3(_759.zyx * vec3(255.0));
            if (_759.w > 0.0)
            {
                break;
            }
        }
        uint _818 = (((uint(_759.w * 255.0) << uint(24)) | (uint(_759.z * 255.0) << uint(16))) | (uint(_759.y * 255.0) << uint(8))) | uint(_759.x * 255.0);
        uvec3 _844 = uvec3((_818 >> uint(19)) & 4095u, (_818 >> uint(7)) & 4095u, _818 & 127u);
        vec3 _858 = vec3(2.0) * ((_750 * vec3(0.5)) + vec3(0.25));
        vec4 _865 = vec4(_721 * (vec3(_844) + _858), 0.0);
        vec4 _876 = textureLod(_877, vec4(_865.xy, _865.z + (_729.z * 0.0), 0.0).xyz, vec4(_865.xy, _865.z + (_729.z * 0.0), 0.0).w) * _642;
        vec4 _906 = textureLod(_877, vec4(_865.xy, _865.z + (_729.z * 1.0), 0.0).xyz, vec4(_865.xy, _865.z + (_729.z * 1.0), 0.0).w) * _642;
        vec4 _935 = textureLod(_877, vec4(_865.xy, _865.z + (_729.z * 2.0), 0.0).xyz, vec4(_865.xy, _865.z + (_729.z * 2.0), 0.0).w) * _642;
        _633 = vec4(_876.x, _906.x, _935.x, _876.y);
        _634 = vec4(_906.y, _935.y, _876.z, _906.z);
        _635 = vec4(_935.z, _876.w, _906.w, _935.w);
    }
    gl_Position.y = -gl_Position.y;

  // Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}


