
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

layout(set = 1, binding = 0, std140) uniform _66_68
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
} _68;

layout(set = 0, binding = 0, std140) uniform _105_107
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
} _107;

layout(set = 2, binding = 0, std140) uniform _165_167
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
} _167;

layout(set = 0, binding = 1, std430) restrict readonly buffer _237_239
{
    vec4 _m0[];
} _239;

layout(push_constant, std430) uniform _1768_1770
{
    int _m0;
    int _m1;
} _1770;

layout(set = 1, binding = 1) uniform sampler2D _1774;
layout(set = 2, binding = 1) uniform sampler2D _1775;
layout(set = 2, binding = 2) uniform sampler2D _1776;

layout(location = 0) in vec4 _157;
layout(location = 3) in vec4 _220;
layout(location = 9) in vec4 _257;
layout(location = 2) in vec4 _273;
layout(location = 2) out vec4 _432;
layout(location = 1) in vec2 _435;
layout(location = 4) in vec2 _440;
layout(location = 8) out vec4 _478;
layout(location = 9) out vec4 _1310;
layout(location = 3) out vec4 _1738;
layout(location = 12) in vec2 _1757;

mat4 _35(mat4 _33, mat4 _34)
{
    return _33 * _34;
}

float _28(vec4 _26, vec4 _27)
{
    return dot(_26, _27);
}

float _17(vec3 _15, vec3 _16)
{
    return dot(_15, _16);
}

float _24(vec4 _22, vec4 _23)
{
    return dot(_22.xyz, _23.xyz);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

void main()
{
    mat4 _65 = mat4(vec4(_68._m0), vec4(_68._m1), vec4(_68._m2), vec4(_68._m3));
    mat4 _104 = mat4(vec4(_107._m0), vec4(_107._m1), vec4(_107._m2), vec4(_107._m3));
    mat4 _138 = _65;
    mat4 _140 = _104;
    mat4 _137 = _35(_138, _140);
    vec4 _143 = _137[0];
    vec4 _146 = _137[1];
    vec4 _149 = _137[2];
    vec4 _152 = _137[3];
    vec3 _155 = _157.xyz;
    vec4 _160;
    _160.x = (_155.x * _167._m0.x) + _167._m1.x;
    _160.y = (_155.y * _167._m0.y) + _167._m1.y;
    _160.z = (_155.z * _167._m0.z) + _167._m1.z;
    _160.w = 1.0;
    if (_167._m2.z != 0.0)
    {
        vec4 _204 = _160;
        vec4 _206 = vec4(0.0);
        vec4 _208 = vec4(0.0);
        vec4 _209 = vec4(0.0);
        uvec4 _212 = uvec4(uint(_68._m4.x + _167._m2.x)) + uvec4(_220 * 255.0);
        if (_167._m2.z == 1.0)
        {
            uint _233 = _212.x;
            _206 = _239._m0[(_233 * 3u) + 0u];
            _208 = _239._m0[(_233 * 3u) + 1u];
            _209 = _239._m0[(_233 * 3u) + 2u];
        }
        else
        {
            float _256 = _257.w * 255.100006103515625;
            vec4 _263;
            _263.y = _256 - (floor(_256 / 128.0) * 128.0);
            float _272 = _273.w * 255.100006103515625;
            _263.z = floor(_272 / 16.0);
            _263.w = _272 - (_263.z * 16.0);
            _263.y *= 0.00393700785934925079345703125;
            _263.z *= 0.02222222276031970977783203125;
            _263.w *= 0.01666666753590106964111328125;
            _263.x = 1.0 - ((_263.y + _263.z) + _263.w);
            for (uint _313 = 0u; _313 < 4u; _313++)
            {
                _206 += (_239._m0[(_212[_313] * 3u) + 0u] * _263[_313]);
            }
            for (uint _337 = 0u; _337 < 4u; _337++)
            {
                _208 += (_239._m0[(_212[_337] * 3u) + 1u] * _263[_337]);
            }
            for (uint _360 = 0u; _360 < 4u; _360++)
            {
                _209 += (_239._m0[(_212[_360] * 3u) + 2u] * _263[_360]);
            }
        }
        vec4 _383 = _204;
        vec4 _385 = _206;
        _160.x = _28(_383, _385);
        vec4 _389 = _204;
        vec4 _391 = _208;
        _160.y = _28(_389, _391);
        vec4 _395 = _204;
        vec4 _397 = _209;
        _160.z = _28(_395, _397);
        _160.w = 1.0;
    }
    vec4 _406 = _160;
    vec4 _408 = _143;
    gl_Position.x = _28(_406, _408);
    vec4 _413 = _160;
    vec4 _415 = _146;
    gl_Position.y = _28(_413, _415);
    vec4 _419 = _160;
    vec4 _421 = _149;
    gl_Position.z = _28(_419, _421);
    vec4 _425 = _160;
    vec4 _427 = _152;
    gl_Position.w = _28(_425, _427);
    _432 = vec4(_435.x, _435.y, _440.x, _440.y);
    vec3 _446 = _157.xyz;
    vec4 _449;
    _449.x = (_446.x * _167._m0.x) + _167._m1.x;
    _449.y = (_446.y * _167._m0.y) + _167._m1.y;
    _449.z = (_446.z * _167._m0.z) + _167._m1.z;
    _449.w = 1.0;
    _478 = vec4(0.0);
    vec3 _479 = vec3(0.0);
    float _481 = sign(_68._m5.y);
    float _486 = _68._m5.y * _481;
    float _491 = _449.y * _481;
    float _496 = max(_486 / max(_486 - _491, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _479 = _68._m5.xyz - _449.xyz;
    _479 *= max(1.0 / ((length(_479) * _496) * sign(-_68._m5.w)), abs(_68._m5.w));
    vec3 _527 = vec3(0.0);
    float _528 = sign(_68._m6.y);
    float _533 = _68._m6.y * _528;
    float _538 = _449.y * _528;
    float _543 = max(_533 / max(_533 - _538, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _527 = _68._m6.xyz - _449.xyz;
    _527 *= max(1.0 / ((length(_527) * _543) * sign(-_68._m6.w)), abs(_68._m6.w));
    vec3 _573 = vec3(0.0);
    float _574 = sign(_68._m7.y);
    float _579 = _68._m7.y * _574;
    float _584 = _449.y * _574;
    float _589 = max(_579 / max(_579 - _584, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _573 = _68._m7.xyz - _449.xyz;
    _573 *= max(1.0 / ((length(_573) * _589) * sign(-_68._m7.w)), abs(_68._m7.w));
    vec3 _619 = vec3(0.0);
    float _620 = sign(_68._m8.y);
    float _625 = _68._m8.y * _620;
    float _630 = _449.y * _620;
    float _635 = max(_625 / max(_625 - _630, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _619 = _68._m8.xyz - _449.xyz;
    _619 *= max(1.0 / ((length(_619) * _635) * sign(-_68._m8.w)), abs(_68._m8.w));
    vec3 _665 = vec3(0.0);
    float _666 = sign(_68._m9.y);
    float _671 = _68._m9.y * _666;
    float _676 = _449.y * _666;
    float _681 = max(_671 / max(_671 - _676, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _665 = _68._m9.xyz - _449.xyz;
    _665 *= max(1.0 / ((length(_665) * _681) * sign(-_68._m9.w)), abs(_68._m9.w));
    vec3 _711 = vec3(0.0);
    float _712 = sign(_68._m10.y);
    float _717 = _68._m10.y * _712;
    float _722 = _449.y * _712;
    float _727 = max(_717 / max(_717 - _722, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _711 = _68._m10.xyz - _449.xyz;
    _711 *= max(1.0 / ((length(_711) * _727) * sign(-_68._m10.w)), abs(_68._m10.w));
    vec3 _757 = vec3(0.0);
    float _758 = sign(_68._m11.y);
    float _763 = _68._m11.y * _758;
    float _768 = _449.y * _758;
    float _773 = max(_763 / max(_763 - _768, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _757 = _68._m11.xyz - _449.xyz;
    _757 *= max(1.0 / ((length(_757) * _773) * sign(-_68._m11.w)), abs(_68._m11.w));
    vec3 _803 = vec3(0.0);
    float _804 = sign(_68._m12.y);
    float _809 = _68._m12.y * _804;
    float _814 = _449.y * _804;
    float _819 = max(_809 / max(_809 - _814, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _803 = _68._m12.xyz - _449.xyz;
    _803 *= max(1.0 / ((length(_803) * _819) * sign(-_68._m12.w)), abs(_68._m12.w));
    vec3 _849 = vec3(0.0);
    float _850 = sign(_68._m13.y);
    float _855 = _68._m13.y * _850;
    float _860 = _449.y * _850;
    float _865 = max(_855 / max(_855 - _860, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _849 = _68._m13.xyz - _449.xyz;
    _849 *= max(1.0 / ((length(_849) * _865) * sign(-_68._m13.w)), abs(_68._m13.w));
    vec3 _895 = vec3(0.0);
    float _896 = sign(_68._m14.y);
    float _901 = _68._m14.y * _896;
    float _906 = _449.y * _896;
    float _911 = max(_901 / max(_901 - _906, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _895 = _68._m14.xyz - _449.xyz;
    _895 *= max(1.0 / ((length(_895) * _911) * sign(-_68._m14.w)), abs(_68._m14.w));
    vec3 _941 = vec3(0.0);
    float _942 = sign(_68._m15.y);
    float _947 = _68._m15.y * _942;
    float _952 = _449.y * _942;
    float _957 = max(_947 / max(_947 - _952, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _941 = _68._m15.xyz - _449.xyz;
    _941 *= max(1.0 / ((length(_941) * _957) * sign(-_68._m15.w)), abs(_68._m15.w));
    vec3 _987 = vec3(0.0);
    float _988 = sign(_68._m16.y);
    float _993 = _68._m16.y * _988;
    float _998 = _449.y * _988;
    float _1003 = max(_993 / max(_993 - _998, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _987 = _68._m16.xyz - _449.xyz;
    _987 *= max(1.0 / ((length(_987) * _1003) * sign(-_68._m16.w)), abs(_68._m16.w));
    vec3 _1033 = (_68._m17.xyz - _449.xyz) * _68._m17.w;
    vec3 _1044 = (_68._m18.xyz - _449.xyz) * _68._m18.w;
    vec3 _1055 = (_68._m19.xyz - _449.xyz) * _68._m19.w;
    vec3 _1066 = (_68._m20.xyz - _449.xyz) * _68._m20.w;
    vec3 _1077 = (_68._m21.xyz - _449.xyz) * _68._m21.w;
    vec3 _1088 = (_68._m22.xyz - _449.xyz) * _68._m22.w;
    vec3 _1099 = (_68._m23.xyz - _449.xyz) * _68._m23.w;
    vec3 _1110 = (_68._m24.xyz - _449.xyz) * _68._m24.w;
    vec3 _1122 = _479;
    vec3 _1124 = _479;
    float _1121 = _17(_1122, _1124);
    vec3 _1128 = _527;
    vec3 _1130 = _527;
    float _1127 = _17(_1128, _1130);
    vec3 _1134 = _573;
    vec3 _1136 = _573;
    float _1133 = _17(_1134, _1136);
    vec3 _1140 = _619;
    vec3 _1142 = _619;
    float _1139 = _17(_1140, _1142);
    vec3 _1146 = _665;
    vec3 _1148 = _665;
    float _1145 = _17(_1146, _1148);
    vec3 _1152 = _711;
    vec3 _1154 = _711;
    float _1151 = _17(_1152, _1154);
    vec3 _1158 = _757;
    vec3 _1160 = _757;
    float _1157 = _17(_1158, _1160);
    vec3 _1164 = _803;
    vec3 _1166 = _803;
    float _1163 = _17(_1164, _1166);
    vec3 _1170 = _849;
    vec3 _1172 = _849;
    float _1169 = _17(_1170, _1172);
    vec3 _1176 = _895;
    vec3 _1178 = _895;
    float _1175 = _17(_1176, _1178);
    vec3 _1182 = _941;
    vec3 _1184 = _941;
    float _1181 = _17(_1182, _1184);
    vec3 _1188 = _987;
    vec3 _1190 = _987;
    float _1187 = _17(_1188, _1190);
    vec3 _1194 = _1033;
    vec3 _1196 = _1033;
    float _1193 = _17(_1194, _1196);
    vec3 _1200 = _1044;
    vec3 _1202 = _1044;
    float _1199 = _17(_1200, _1202);
    vec3 _1206 = _1055;
    vec3 _1208 = _1055;
    float _1205 = _17(_1206, _1208);
    vec3 _1212 = _1066;
    vec3 _1214 = _1066;
    float _1211 = _17(_1212, _1214);
    vec3 _1218 = _1077;
    vec3 _1220 = _1077;
    float _1217 = _17(_1218, _1220);
    vec3 _1224 = _1088;
    vec3 _1226 = _1088;
    float _1223 = _17(_1224, _1226);
    vec3 _1230 = _1099;
    vec3 _1232 = _1099;
    float _1229 = _17(_1230, _1232);
    vec3 _1236 = _1110;
    vec3 _1238 = _1110;
    float _1235 = _17(_1236, _1238);
    float _1241 = min(_1121, _1127);
    _1241 = min(_1241, _1133);
    _1241 = min(_1241, _1139);
    _1241 = min(_1241, _1145);
    _1241 = min(_1241, _1151);
    _1241 = min(_1241, _1157);
    _1241 = min(_1241, _1163);
    _1241 = min(_1241, _1169);
    _1241 = min(_1241, _1175);
    _1241 = min(_1241, _1181);
    _1241 = min(_1241, _1187);
    float _1275 = min(_1193, _1199);
    _1275 = min(_1275, _1205);
    _1275 = min(_1275, _1211);
    _1275 = min(_1275, _1217);
    _1275 = min(_1275, _1223);
    _1275 = min(_1275, _1229);
    _1275 = min(_1275, _1235);
    float _1297 = sqrt(min(_1241, _1275)) - 1.0;
    float _1303 = sqrt(_1241) - 1.0;
    _478 = vec4(_1297, 0.0, 0.0, _1303);
    _1310 = _432 * vec4(_68._m25.xy, 0.0, 0.0);
    vec3 _1320 = _157.xyz;
    vec4 _1323;
    _1323.x = (_1320.x * _167._m0.x) + _167._m1.x;
    _1323.y = (_1320.y * _167._m0.y) + _167._m1.y;
    _1323.z = (_1320.z * _167._m0.z) + _167._m1.z;
    _1323.w = 1.0;
    vec4 _1352 = (_273 * 2.0) - vec4(1.0);
    vec4 _1358 = (_257 * 2.0) - vec4(1.0);
    _1358.w = (floor((_257.w * 255.100006103515625) / 128.0) * 2.0) - 1.0;
    float _1371 = 0.0;
    if (_167._m2.z != 0.0)
    {
        vec4 _1377 = _1323;
        vec4 _1379 = vec4(0.0);
        vec4 _1380 = vec4(0.0);
        vec4 _1381 = vec4(0.0);
        uvec4 _1382 = uvec4(uint(_68._m4.x + _167._m2.x)) + uvec4(_220 * 255.0);
        if (_167._m2.z == 1.0)
        {
            uint _1399 = _1382.x;
            _1379 = _239._m0[(_1399 * 3u) + 0u];
            _1380 = _239._m0[(_1399 * 3u) + 1u];
            _1381 = _239._m0[(_1399 * 3u) + 2u];
        }
        else
        {
            float _1418 = _257.w * 255.100006103515625;
            vec4 _1422;
            _1422.y = _1418 - (floor(_1418 / 128.0) * 128.0);
            float _1430 = _273.w * 255.100006103515625;
            _1422.z = floor(_1430 / 16.0);
            _1422.w = _1430 - (_1422.z * 16.0);
            _1422.y *= 0.00393700785934925079345703125;
            _1422.z *= 0.02222222276031970977783203125;
            _1422.w *= 0.01666666753590106964111328125;
            _1422.x = 1.0 - ((_1422.y + _1422.z) + _1422.w);
            for (uint _1466 = 0u; _1466 < 4u; _1466++)
            {
                _1379 += (_239._m0[(_1382[_1466] * 3u) + 0u] * _1422[_1466]);
            }
            for (uint _1489 = 0u; _1489 < 4u; _1489++)
            {
                _1380 += (_239._m0[(_1382[_1489] * 3u) + 1u] * _1422[_1489]);
            }
            for (uint _1512 = 0u; _1512 < 4u; _1512++)
            {
                _1381 += (_239._m0[(_1382[_1512] * 3u) + 2u] * _1422[_1512]);
            }
        }
        vec4 _1535 = _1377;
        vec4 _1537 = _1379;
        _1323.x = _28(_1535, _1537);
        vec4 _1541 = _1377;
        vec4 _1543 = _1380;
        _1323.y = _28(_1541, _1543);
        vec4 _1547 = _1377;
        vec4 _1549 = _1381;
        _1323.z = _28(_1547, _1549);
        _1323.w = 1.0;
        vec4 _1554 = _1352;
        vec4 _1556 = _1554;
        vec4 _1558 = _1379;
        _1352.x = _24(_1556, _1558);
        vec4 _1562 = _1554;
        vec4 _1564 = _1380;
        _1352.y = _24(_1562, _1564);
        vec4 _1568 = _1554;
        vec4 _1570 = _1381;
        _1352.z = _24(_1568, _1570);
        vec4 _1574 = _1358;
        vec4 _1576 = _1574;
        vec4 _1578 = _1379;
        _1358.x = _24(_1576, _1578);
        vec4 _1582 = _1574;
        vec4 _1584 = _1380;
        _1358.y = _24(_1582, _1584);
        vec4 _1588 = _1574;
        vec4 _1590 = _1381;
        _1358.z = _24(_1588, _1590);
    }
    float _1594 = length(_68._m26.xyz - _1323.xyz);
    float _1613 = abs(_1594 - _68._m27.z) / _68._m27.x;
    float _1603 = 1.0 - _10(_1613);
    float _1616 = ((_1603 * _1603) * _68._m27.y) * 0.00999999977648258209228515625;
    _1323 += (_1352 * vec4(_1616, _1616, _1616, 0.0));
    mat4 _1633 = mat4(vec4(_68._m0), vec4(_68._m1), vec4(_68._m2), vec4(_68._m3));
    mat4 _1663 = mat4(vec4(_107._m0), vec4(_107._m1), vec4(_107._m2), vec4(_107._m3));
    mat4 _1694 = _1633;
    mat4 _1696 = _1663;
    mat4 _1693 = _35(_1694, _1696);
    vec4 _1699 = _1693[0];
    vec4 _1702 = _1693[1];
    vec4 _1705 = _1693[2];
    vec4 _1708 = _1693[3];
    vec4 _1711 = _1323;
    vec4 _1713 = _1699;
    gl_Position.x = _28(_1711, _1713);
    vec4 _1717 = _1323;
    vec4 _1719 = _1702;
    gl_Position.y = _28(_1717, _1719);
    vec4 _1723 = _1323;
    vec4 _1725 = _1705;
    gl_Position.z = _28(_1723, _1725);
    vec4 _1729 = _1323;
    vec4 _1731 = _1708;
    gl_Position.w = _28(_1729, _1731);
    vec2 _1736 = _435;
    _1738.x = (_1736.x * _167._m3.x) + _167._m3.z;
    _1738.y = (_1736.y * _167._m3.y) + _167._m3.w;
    _1738.z = _1757.x;
    _1738.w = _1757.y;
    gl_Position.y = -gl_Position.y;
}

