// Cloak mode clour
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _20
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 0, binding = 1, std430) restrict readonly buffer _22_24
{
    _20 _m0[];
} _24;

layout(set = 2, binding = 0, std140) uniform _67_69
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
} _69;

layout(set = 0, binding = 0, std140) uniform _111_113
{
    vec4 _m0;
    vec4 _m1;
} _113;

layout(set = 1, binding = 0, std140) uniform _161_163
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
} _163;

layout(set = 0, binding = 2, std430) restrict readonly buffer _380_382
{
    vec4 _m0[];
} _382;

layout(push_constant, std430) uniform _27_29
{
    int _m0;
    int _m1;
} _29;

layout(location = 0) in vec4 _58;
layout(location = 3) in vec4 _146;
layout(location = 9) in vec4 _400;
layout(location = 2) in vec4 _416;

float _12(vec4 _10, vec4 _11)
{
    return dot(_10, _11);
}

void main()
{
    vec4 _19 = _24._m0[_29._m1]._m0;
    vec4 _37 = _24._m0[_29._m1]._m1;
    vec4 _42 = _24._m0[_29._m1]._m2;
    vec4 _48 = _24._m0[_29._m1]._m3;
    vec3 _56 = _58.xyz;
    vec4 _61;
    _61.x = (_56.x * _69._m11.x) + _69._m12.x;
    _61.y = (_56.y * _69._m11.y) + _69._m12.y;
    _61.z = (_56.z * _69._m11.z) + _69._m12.z;
    _61.w = 1.0;
    bool _108 = _69._m4.x != 0.0;
    bool _118;
    if (_108)
    {
        _118 = _113._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _118 = _108;
    }
    bool _125;
    if (_118)
    {
        _125 = _69._m5.x > 0.0;
    }
    else
    {
        _125 = _118;
    }
    if (_125)
    {
        vec3 _128 = vec3(_113._m0.xy, 0.0);
        float _136 = _69._m4.x;
        float _139 = _69._m4.y;
        float _142 = _69._m4.w;
        vec4 _145 = _146;
        float _148 = _69._m5.x;
        float _151 = _69._m5.y;
        float _154 = _69._m5.z;
        float _157 = _69._m5.w;
        vec4 _164 = _61;
        vec4 _166 = _163._m4;
        vec4 _160;
        _160.x = _12(_164, _166);
        vec4 _171 = _61;
        vec4 _173 = _163._m5;
        _160.y = _12(_171, _173);
        vec4 _179 = _61;
        vec4 _181 = _163._m6;
        _160.z = _12(_179, _181);
        _160.w = 1.0;
        float _187 = dot(_160.xyz, _128) * _148;
        float _194 = _145.z * _157;
        float _199 = _163._m4.w * _163._m5.w;
        float _205 = ((_113._m1.x * _69._m4.z) * _148) - _187;
        float _215 = (_145.x * 1.0) - _194;
        float _221 = sin(_205 - _215);
        float _226 = sin((_205 * 1.33000004291534423828125) - _215);
        float _233 = ((_221 + _226) * 0.25) + 0.5;
        _233 *= _233;
        float _244 = (_233 * (_139 - _136)) + _136;
        vec3 _252 = _128 * vec3(_244);
        float _257 = ((_145.y * 16.0) - _199) - _194;
        float _266 = sin(((_113._m1.x * 4.0) * _151) + _257);
        float _276 = cos(((_113._m1.x * 3.3299999237060546875) * _151) + _257);
        float _286 = (_266 + _276) * (-_145.w);
        vec3 _294 = vec3(_266 * _142, _276 * _142, _286 * _154) * vec3(_244);
        vec3 _308 = ((_252 + _294) * _113._m0.z) * _145.z;
        vec3 _321 = _160.xyz + _308;
        _160 = vec4(_321.x, _321.y, _321.z, _160.w);
        _160.w = 1.0;
        _61.x = dot(_160, _163._m12);
        _61.y = dot(_160, _163._m13);
        _61.z = dot(_160, _163._m14);
    }
    if (_69._m7.z != 0.0)
    {
        vec4 _348 = _61;
        vec4 _350 = vec4(0.0);
        vec4 _352 = vec4(0.0);
        vec4 _353 = vec4(0.0);
        uvec4 _356 = uvec4(uint(_163._m20.x + _69._m7.x)) + uvec4(_146 * 255.0);
        if (_69._m7.z == 1.0)
        {
            uint _376 = _356.x;
            _350 = _382._m0[(_376 * 3u) + 0u];
            _352 = _382._m0[(_376 * 3u) + 1u];
            _353 = _382._m0[(_376 * 3u) + 2u];
        }
        else
        {
            float _399 = _400.w * 255.100006103515625;
            vec4 _406;
            _406.y = _399 - (floor(_399 / 128.0) * 128.0);
            float _415 = _416.w * 255.100006103515625;
            _406.z = floor(_415 / 16.0);
            _406.w = _415 - (_406.z * 16.0);
            _406.y *= 0.00393700785934925079345703125;
            _406.z *= 0.02222222276031970977783203125;
            _406.w *= 0.01666666753590106964111328125;
            _406.x = 1.0 - ((_406.y + _406.z) + _406.w);
            for (uint _455 = 0u; _455 < 4u; _455++)
            {
                _350 += (_382._m0[(_356[_455] * 3u) + 0u] * _406[_455]);
            }
            for (uint _479 = 0u; _479 < 4u; _479++)
            {
                _352 += (_382._m0[(_356[_479] * 3u) + 1u] * _406[_479]);
            }
            for (uint _502 = 0u; _502 < 4u; _502++)
            {
                _353 += (_382._m0[(_356[_502] * 3u) + 2u] * _406[_502]);
            }
        }
        vec4 _525 = _348;
        vec4 _527 = _350;
        _61.x = _12(_525, _527);
        vec4 _531 = _348;
        vec4 _533 = _352;
        _61.y = _12(_531, _533);
        vec4 _537 = _348;
        vec4 _539 = _353;
        _61.z = _12(_537, _539);
        _61.w = 1.0;
    }
    vec4 _548 = _61;
    vec4 _550 = _19;
    gl_Position.x = _12(_548, _550);
    vec4 _555 = _61;
    vec4 _557 = _37;
    gl_Position.y = _12(_555, _557);
    vec4 _561 = _61;
    vec4 _563 = _42;
    gl_Position.z = _12(_561, _563);
    vec4 _567 = _61;
    vec4 _569 = _48;
    gl_Position.w = _12(_567, _569);
    gl_Position.y = -gl_Position.y;

 // Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}


