
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

layout(set = 1, binding = 0, std140) uniform _44_46
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
} _46;

layout(set = 0, binding = 0, std140) uniform _85_87
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
} _87;

layout(set = 2, binding = 0, std140) uniform _146_148
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
} _148;

layout(set = 0, binding = 1, std430) restrict readonly buffer _218_220
{
    vec4 _m0[];
} _220;

layout(push_constant, std430) uniform _1320_1322
{
    int _m0;
    int _m1;
} _1322;

layout(set = 0, binding = 2) uniform sampler2D _1326;
layout(set = 1, binding = 1) uniform sampler2D _1327;
layout(set = 1, binding = 2) uniform sampler2D _1328;

layout(location = 0) in vec4 _137;
layout(location = 3) in vec4 _201;
layout(location = 9) in vec4 _238;
layout(location = 2) in vec4 _254;
layout(location = 1) in vec2 _416;
layout(location = 2) out vec4 _419;
layout(location = 8) out vec4 _474;
layout(location = 9) out vec4 _1306;

mat4 _26(mat4 _24, mat4 _25)
{
    return _24 * _25;
}

float _19(vec4 _17, vec4 _18)
{
    return dot(_17, _18);
}

float _12(vec3 _10, vec3 _11)
{
    return dot(_10, _11);
}

void main()
{
    mat4 _43 = mat4(vec4(_46._m0), vec4(_46._m1), vec4(_46._m2), vec4(_46._m3));
    mat4 _84 = mat4(vec4(_87._m0), vec4(_87._m1), vec4(_87._m2), vec4(_87._m3));
    mat4 _118 = _43;
    mat4 _120 = _84;
    mat4 _117 = _26(_118, _120);
    vec4 _123 = _117[0];
    vec4 _126 = _117[1];
    vec4 _129 = _117[2];
    vec4 _132 = _117[3];
    vec3 _135 = _137.xyz;
    vec4 _140;
    _140.x = (_135.x * _148._m0.x) + _148._m1.x;
    _140.y = (_135.y * _148._m0.y) + _148._m1.y;
    _140.z = (_135.z * _148._m0.z) + _148._m1.z;
    _140.w = 1.0;
    if (_148._m2.z != 0.0)
    {
        vec4 _185 = _140;
        vec4 _187 = vec4(0.0);
        vec4 _189 = vec4(0.0);
        vec4 _190 = vec4(0.0);
        uvec4 _193 = uvec4(uint(_46._m4.x + _148._m2.x)) + uvec4(_201 * 255.0);
        if (_148._m2.z == 1.0)
        {
            uint _214 = _193.x;
            _187 = _220._m0[(_214 * 3u) + 0u];
            _189 = _220._m0[(_214 * 3u) + 1u];
            _190 = _220._m0[(_214 * 3u) + 2u];
        }
        else
        {
            float _237 = _238.w * 255.100006103515625;
            vec4 _244;
            _244.y = _237 - (floor(_237 / 128.0) * 128.0);
            float _253 = _254.w * 255.100006103515625;
            _244.z = floor(_253 / 16.0);
            _244.w = _253 - (_244.z * 16.0);
            _244.y *= 0.00393700785934925079345703125;
            _244.z *= 0.02222222276031970977783203125;
            _244.w *= 0.01666666753590106964111328125;
            _244.x = 1.0 - ((_244.y + _244.z) + _244.w);
            for (uint _294 = 0u; _294 < 4u; _294++)
            {
                _187 += (_220._m0[(_193[_294] * 3u) + 0u] * _244[_294]);
            }
            for (uint _318 = 0u; _318 < 4u; _318++)
            {
                _189 += (_220._m0[(_193[_318] * 3u) + 1u] * _244[_318]);
            }
            for (uint _341 = 0u; _341 < 4u; _341++)
            {
                _190 += (_220._m0[(_193[_341] * 3u) + 2u] * _244[_341]);
            }
        }
        vec4 _364 = _185;
        vec4 _366 = _187;
        _140.x = _19(_364, _366);
        vec4 _370 = _185;
        vec4 _372 = _189;
        _140.y = _19(_370, _372);
        vec4 _376 = _185;
        vec4 _378 = _190;
        _140.z = _19(_376, _378);
        _140.w = 1.0;
    }
    vec4 _387 = _140;
    vec4 _389 = _123;
    gl_Position.x = _19(_387, _389);
    vec4 _394 = _140;
    vec4 _396 = _126;
    gl_Position.y = _19(_394, _396);
    vec4 _400 = _140;
    vec4 _402 = _129;
    gl_Position.z = _19(_400, _402);
    vec4 _406 = _140;
    vec4 _408 = _132;
    gl_Position.w = _19(_406, _408);
    vec2 _414 = _416;
    _419.x = (_414.x * _148._m3.x) + _148._m3.z;
    _419.y = (_414.y * _148._m3.y) + _148._m3.w;
    _419 = vec4(_419.x, _419.y, _419.xy.x, _419.xy.y);
    vec3 _442 = _137.xyz;
    vec4 _445;
    _445.x = (_442.x * _148._m0.x) + _148._m1.x;
    _445.y = (_442.y * _148._m0.y) + _148._m1.y;
    _445.z = (_442.z * _148._m0.z) + _148._m1.z;
    _445.w = 1.0;
    _474 = vec4(0.0);
    vec3 _475 = vec3(0.0);
    float _477 = sign(_46._m5.y);
    float _482 = _46._m5.y * _477;
    float _487 = _445.y * _477;
    float _492 = max(_482 / max(_482 - _487, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _475 = _46._m5.xyz - _445.xyz;
    _475 *= max(1.0 / ((length(_475) * _492) * sign(-_46._m5.w)), abs(_46._m5.w));
    vec3 _523 = vec3(0.0);
    float _524 = sign(_46._m6.y);
    float _529 = _46._m6.y * _524;
    float _534 = _445.y * _524;
    float _539 = max(_529 / max(_529 - _534, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _523 = _46._m6.xyz - _445.xyz;
    _523 *= max(1.0 / ((length(_523) * _539) * sign(-_46._m6.w)), abs(_46._m6.w));
    vec3 _569 = vec3(0.0);
    float _570 = sign(_46._m7.y);
    float _575 = _46._m7.y * _570;
    float _580 = _445.y * _570;
    float _585 = max(_575 / max(_575 - _580, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _569 = _46._m7.xyz - _445.xyz;
    _569 *= max(1.0 / ((length(_569) * _585) * sign(-_46._m7.w)), abs(_46._m7.w));
    vec3 _615 = vec3(0.0);
    float _616 = sign(_46._m8.y);
    float _621 = _46._m8.y * _616;
    float _626 = _445.y * _616;
    float _631 = max(_621 / max(_621 - _626, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _615 = _46._m8.xyz - _445.xyz;
    _615 *= max(1.0 / ((length(_615) * _631) * sign(-_46._m8.w)), abs(_46._m8.w));
    vec3 _661 = vec3(0.0);
    float _662 = sign(_46._m9.y);
    float _667 = _46._m9.y * _662;
    float _672 = _445.y * _662;
    float _677 = max(_667 / max(_667 - _672, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _661 = _46._m9.xyz - _445.xyz;
    _661 *= max(1.0 / ((length(_661) * _677) * sign(-_46._m9.w)), abs(_46._m9.w));
    vec3 _707 = vec3(0.0);
    float _708 = sign(_46._m10.y);
    float _713 = _46._m10.y * _708;
    float _718 = _445.y * _708;
    float _723 = max(_713 / max(_713 - _718, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _707 = _46._m10.xyz - _445.xyz;
    _707 *= max(1.0 / ((length(_707) * _723) * sign(-_46._m10.w)), abs(_46._m10.w));
    vec3 _753 = vec3(0.0);
    float _754 = sign(_46._m11.y);
    float _759 = _46._m11.y * _754;
    float _764 = _445.y * _754;
    float _769 = max(_759 / max(_759 - _764, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _753 = _46._m11.xyz - _445.xyz;
    _753 *= max(1.0 / ((length(_753) * _769) * sign(-_46._m11.w)), abs(_46._m11.w));
    vec3 _799 = vec3(0.0);
    float _800 = sign(_46._m12.y);
    float _805 = _46._m12.y * _800;
    float _810 = _445.y * _800;
    float _815 = max(_805 / max(_805 - _810, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _799 = _46._m12.xyz - _445.xyz;
    _799 *= max(1.0 / ((length(_799) * _815) * sign(-_46._m12.w)), abs(_46._m12.w));
    vec3 _845 = vec3(0.0);
    float _846 = sign(_46._m13.y);
    float _851 = _46._m13.y * _846;
    float _856 = _445.y * _846;
    float _861 = max(_851 / max(_851 - _856, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _845 = _46._m13.xyz - _445.xyz;
    _845 *= max(1.0 / ((length(_845) * _861) * sign(-_46._m13.w)), abs(_46._m13.w));
    vec3 _891 = vec3(0.0);
    float _892 = sign(_46._m14.y);
    float _897 = _46._m14.y * _892;
    float _902 = _445.y * _892;
    float _907 = max(_897 / max(_897 - _902, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _891 = _46._m14.xyz - _445.xyz;
    _891 *= max(1.0 / ((length(_891) * _907) * sign(-_46._m14.w)), abs(_46._m14.w));
    vec3 _937 = vec3(0.0);
    float _938 = sign(_46._m15.y);
    float _943 = _46._m15.y * _938;
    float _948 = _445.y * _938;
    float _953 = max(_943 / max(_943 - _948, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _937 = _46._m15.xyz - _445.xyz;
    _937 *= max(1.0 / ((length(_937) * _953) * sign(-_46._m15.w)), abs(_46._m15.w));
    vec3 _983 = vec3(0.0);
    float _984 = sign(_46._m16.y);
    float _989 = _46._m16.y * _984;
    float _994 = _445.y * _984;
    float _999 = max(_989 / max(_989 - _994, 9.9999999747524270787835121154785e-07), 9.9999999747524270787835121154785e-07);
    _983 = _46._m16.xyz - _445.xyz;
    _983 *= max(1.0 / ((length(_983) * _999) * sign(-_46._m16.w)), abs(_46._m16.w));
    vec3 _1029 = (_46._m17.xyz - _445.xyz) * _46._m17.w;
    vec3 _1040 = (_46._m18.xyz - _445.xyz) * _46._m18.w;
    vec3 _1051 = (_46._m19.xyz - _445.xyz) * _46._m19.w;
    vec3 _1062 = (_46._m20.xyz - _445.xyz) * _46._m20.w;
    vec3 _1073 = (_46._m21.xyz - _445.xyz) * _46._m21.w;
    vec3 _1084 = (_46._m22.xyz - _445.xyz) * _46._m22.w;
    vec3 _1095 = (_46._m23.xyz - _445.xyz) * _46._m23.w;
    vec3 _1106 = (_46._m24.xyz - _445.xyz) * _46._m24.w;
    vec3 _1118 = _475;
    vec3 _1120 = _475;
    float _1117 = _12(_1118, _1120);
    vec3 _1124 = _523;
    vec3 _1126 = _523;
    float _1123 = _12(_1124, _1126);
    vec3 _1130 = _569;
    vec3 _1132 = _569;
    float _1129 = _12(_1130, _1132);
    vec3 _1136 = _615;
    vec3 _1138 = _615;
    float _1135 = _12(_1136, _1138);
    vec3 _1142 = _661;
    vec3 _1144 = _661;
    float _1141 = _12(_1142, _1144);
    vec3 _1148 = _707;
    vec3 _1150 = _707;
    float _1147 = _12(_1148, _1150);
    vec3 _1154 = _753;
    vec3 _1156 = _753;
    float _1153 = _12(_1154, _1156);
    vec3 _1160 = _799;
    vec3 _1162 = _799;
    float _1159 = _12(_1160, _1162);
    vec3 _1166 = _845;
    vec3 _1168 = _845;
    float _1165 = _12(_1166, _1168);
    vec3 _1172 = _891;
    vec3 _1174 = _891;
    float _1171 = _12(_1172, _1174);
    vec3 _1178 = _937;
    vec3 _1180 = _937;
    float _1177 = _12(_1178, _1180);
    vec3 _1184 = _983;
    vec3 _1186 = _983;
    float _1183 = _12(_1184, _1186);
    vec3 _1190 = _1029;
    vec3 _1192 = _1029;
    float _1189 = _12(_1190, _1192);
    vec3 _1196 = _1040;
    vec3 _1198 = _1040;
    float _1195 = _12(_1196, _1198);
    vec3 _1202 = _1051;
    vec3 _1204 = _1051;
    float _1201 = _12(_1202, _1204);
    vec3 _1208 = _1062;
    vec3 _1210 = _1062;
    float _1207 = _12(_1208, _1210);
    vec3 _1214 = _1073;
    vec3 _1216 = _1073;
    float _1213 = _12(_1214, _1216);
    vec3 _1220 = _1084;
    vec3 _1222 = _1084;
    float _1219 = _12(_1220, _1222);
    vec3 _1226 = _1095;
    vec3 _1228 = _1095;
    float _1225 = _12(_1226, _1228);
    vec3 _1232 = _1106;
    vec3 _1234 = _1106;
    float _1231 = _12(_1232, _1234);
    float _1237 = min(_1117, _1123);
    _1237 = min(_1237, _1129);
    _1237 = min(_1237, _1135);
    _1237 = min(_1237, _1141);
    _1237 = min(_1237, _1147);
    _1237 = min(_1237, _1153);
    _1237 = min(_1237, _1159);
    _1237 = min(_1237, _1165);
    _1237 = min(_1237, _1171);
    _1237 = min(_1237, _1177);
    _1237 = min(_1237, _1183);
    float _1271 = min(_1189, _1195);
    _1271 = min(_1271, _1201);
    _1271 = min(_1271, _1207);
    _1271 = min(_1271, _1213);
    _1271 = min(_1271, _1219);
    _1271 = min(_1271, _1225);
    _1271 = min(_1271, _1231);
    float _1293 = sqrt(min(_1237, _1271)) - 1.0;
    float _1299 = sqrt(_1237) - 1.0;
    _474 = vec4(_1293, 0.0, 0.0, _1299);
    _1306 = _419 * vec4(_46._m25.xy, 1.0, 1.0);
    gl_Position.y = -gl_Position.y;
}

