#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _324
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 2, binding = 0, std140) uniform _44_46
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
} _46;

layout(set = 0, binding = 0, std140) uniform _89_91
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _91;

layout(set = 1, binding = 0, std140) uniform _141_143
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
} _143;

layout(set = 0, binding = 1, std430) restrict readonly buffer _326_328
{
    _324 _m0[];
} _328;

layout(push_constant, std430) uniform _329_331
{
    int _m0;
    int _m1;
} _331;

layout(location = 0) in vec4 _35;
layout(location = 3) in vec4 _126;
layout(location = 10) out vec4 _742;
layout(location = 11) out vec4 _1097;

float _12(vec4 _10, vec4 _11)
{
    return dot(_10, _11);
}

mat4 _19(mat4 _17, mat4 _18)
{
    return _17 * _18;
}

void main()
{
    vec3 _33 = _35.xyz;
    vec4 _38;
    _38.x = (_33.x * _46._m11.x) + _46._m12.x;
    _38.y = (_33.y * _46._m11.y) + _46._m12.y;
    _38.z = (_33.z * _46._m11.z) + _46._m12.z;
    _38.w = 1.0;
    bool _86 = _46._m4.x != 0.0;
    bool _97;
    if (_86)
    {
        _97 = _91._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _97 = _86;
    }
    bool _104;
    if (_97)
    {
        _104 = _46._m5.x > 0.0;
    }
    else
    {
        _104 = _97;
    }
    if (_104)
    {
        vec3 _107 = vec3(_91._m0.xy, 0.0);
        float _116 = _46._m4.x;
        float _119 = _46._m4.y;
        float _122 = _46._m4.w;
        vec4 _125 = _126;
        float _128 = _46._m5.x;
        float _131 = _46._m5.y;
        float _134 = _46._m5.z;
        float _137 = _46._m5.w;
        vec4 _144 = _38;
        vec4 _146 = _143._m4;
        vec4 _140;
        _140.x = _12(_144, _146);
        vec4 _151 = _38;
        vec4 _153 = _143._m5;
        _140.y = _12(_151, _153);
        vec4 _159 = _38;
        vec4 _161 = _143._m6;
        _140.z = _12(_159, _161);
        _140.w = 1.0;
        float _167 = dot(_140.xyz, _107) * _128;
        float _174 = _125.z * _137;
        float _179 = _143._m4.w * _143._m5.w;
        float _185 = ((_91._m1.x * _46._m4.z) * _128) - _167;
        float _196 = (_125.x * 1.0) - _174;
        float _202 = sin(_185 - _196);
        float _207 = sin((_185 * 1.33000004291534423828125) - _196);
        float _214 = ((_202 + _207) * 0.25) + 0.5;
        _214 *= _214;
        float _225 = (_214 * (_119 - _116)) + _116;
        vec3 _233 = _107 * vec3(_225);
        float _238 = ((_125.y * 16.0) - _179) - _174;
        float _247 = sin(((_91._m1.x * 4.0) * _131) + _238);
        float _257 = cos(((_91._m1.x * 3.3299999237060546875) * _131) + _238);
        float _267 = (_247 + _257) * (-_125.w);
        vec3 _275 = vec3(_247 * _122, _257 * _122, _267 * _134) * vec3(_225);
        vec3 _289 = ((_233 + _275) * _91._m0.z) * _125.z;
        vec3 _302 = _140.xyz + _289;
        _140 = vec4(_302.x, _302.y, _302.z, _140.w);
        _140.w = 1.0;
        _38.x = dot(_140, _143._m12);
        _38.y = dot(_140, _143._m13);
        _38.z = dot(_140, _143._m14);
    }
    vec4 _323 = _328._m0[_331._m1]._m0;
    vec4 _337 = _328._m0[_331._m1]._m1;
    vec4 _342 = _328._m0[_331._m1]._m2;
    vec4 _348 = _328._m0[_331._m1]._m3;
    vec4 _358 = _38;
    vec4 _360 = _323;
    gl_Position.x = _12(_358, _360);
    vec4 _365 = _38;
    vec4 _367 = _337;
    gl_Position.y = _12(_365, _367);
    vec4 _371 = _38;
    vec4 _373 = _342;
    gl_Position.z = _12(_371, _373);
    vec4 _377 = _38;
    vec4 _379 = _348;
    gl_Position.w = _12(_377, _379);
    float _383 = _91._m1.x;
    float _386 = _91._m1.x - _91._m1.y;
    mat4 _392 = mat4(vec4(_143._m4), vec4(_143._m5), vec4(_143._m6), vec4(_143._m3));
    mat4 _422 = mat4(vec4(_91._m2), vec4(_91._m3), vec4(_91._m4), vec4(_91._m5));
    mat4 _453 = _392;
    mat4 _455 = _422;
    mat4 _452 = _19(_453, _455);
    vec4 _458 = _452[0];
    vec4 _461 = _452[1];
    vec4 _464 = _452[2];
    vec4 _467 = _452[3];
    vec3 _470 = _35.xyz;
    vec4 _473;
    _473.x = (_470.x * _46._m11.x) + _46._m12.x;
    _473.y = (_470.y * _46._m11.y) + _46._m12.y;
    _473.z = (_470.z * _46._m11.z) + _46._m12.z;
    _473.w = 1.0;
    bool _504 = _46._m4.x != 0.0;
    bool _510;
    if (_504)
    {
        _510 = _91._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _510 = _504;
    }
    bool _516;
    if (_510)
    {
        _516 = _46._m5.x > 0.0;
    }
    else
    {
        _516 = _510;
    }
    if (_516)
    {
        vec3 _519 = vec3(_91._m0.xy, 0.0);
        float _526 = _46._m4.x;
        float _529 = _46._m4.y;
        float _532 = _46._m4.w;
        vec4 _535 = _126;
        float _537 = _46._m5.x;
        float _540 = _46._m5.y;
        float _543 = _46._m5.z;
        float _546 = _46._m5.w;
        vec4 _550 = _473;
        vec4 _552 = _143._m4;
        vec4 _549;
        _549.x = _12(_550, _552);
        vec4 _557 = _473;
        vec4 _559 = _143._m5;
        _549.y = _12(_557, _559);
        vec4 _564 = _473;
        vec4 _566 = _143._m6;
        _549.z = _12(_564, _566);
        _549.w = 1.0;
        float _572 = dot(_549.xyz, _519) * _537;
        float _579 = _535.z * _546;
        float _584 = _143._m4.w * _143._m5.w;
        float _590 = ((_383 * _46._m4.z) * _537) - _572;
        float _599 = (_535.x * 1.0) - _579;
        float _605 = sin(_590 - _599);
        float _610 = sin((_590 * 1.33000004291534423828125) - _599);
        float _616 = ((_605 + _610) * 0.25) + 0.5;
        _616 *= _616;
        float _625 = (_616 * (_529 - _526)) + _526;
        vec3 _633 = _519 * vec3(_625);
        float _638 = ((_535.y * 16.0) - _584) - _579;
        float _646 = sin(((_383 * 4.0) * _540) + _638);
        float _654 = cos(((_383 * 3.3299999237060546875) * _540) + _638);
        float _662 = (_646 + _654) * (-_535.w);
        vec3 _670 = vec3(_646 * _532, _654 * _532, _662 * _543) * vec3(_625);
        vec3 _684 = ((_633 + _670) * _91._m0.z) * _535.z;
        vec3 _697 = _549.xyz + _684;
        _549 = vec4(_697.x, _697.y, _697.z, _549.w);
        _549.w = 1.0;
        _473.x = dot(_549, _143._m12);
        _473.y = dot(_549, _143._m13);
        _473.z = dot(_549, _143._m14);
    }
    vec4 _717 = _473;
    vec4 _719 = _458;
    vec4 _716;
    _716.x = _12(_717, _719);
    vec4 _723 = _473;
    vec4 _725 = _461;
    _716.y = _12(_723, _725);
    vec4 _729 = _473;
    vec4 _731 = _464;
    _716.z = _12(_729, _731);
    vec4 _735 = _473;
    vec4 _737 = _467;
    _716.w = _12(_735, _737);
    _742 = _716;
    mat4 _744 = mat4(vec4(_143._m7), vec4(_143._m8), vec4(_143._m9), vec4(_143._m10));
    mat4 _778 = mat4(vec4(_91._m6), vec4(_91._m7), vec4(_91._m8), vec4(_91._m9));
    mat4 _809 = _744;
    mat4 _811 = _778;
    mat4 _808 = _19(_809, _811);
    vec4 _814 = _808[0];
    vec4 _817 = _808[1];
    vec4 _820 = _808[2];
    vec4 _823 = _808[3];
    vec3 _826 = _35.xyz;
    vec4 _829;
    _829.x = (_826.x * _46._m11.x) + _46._m12.x;
    _829.y = (_826.y * _46._m11.y) + _46._m12.y;
    _829.z = (_826.z * _46._m11.z) + _46._m12.z;
    _829.w = 1.0;
    bool _860 = _46._m4.x != 0.0;
    bool _866;
    if (_860)
    {
        _866 = _91._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _866 = _860;
    }
    bool _872;
    if (_866)
    {
        _872 = _46._m5.x > 0.0;
    }
    else
    {
        _872 = _866;
    }
    if (_872)
    {
        vec3 _875 = vec3(_91._m0.xy, 0.0);
        float _882 = _46._m4.x;
        float _885 = _46._m4.y;
        float _888 = _46._m4.w;
        vec4 _891 = _126;
        float _893 = _46._m5.x;
        float _896 = _46._m5.y;
        float _899 = _46._m5.z;
        float _902 = _46._m5.w;
        vec4 _906 = _829;
        vec4 _908 = _143._m4;
        vec4 _905;
        _905.x = _12(_906, _908);
        vec4 _913 = _829;
        vec4 _915 = _143._m5;
        _905.y = _12(_913, _915);
        vec4 _920 = _829;
        vec4 _922 = _143._m6;
        _905.z = _12(_920, _922);
        _905.w = 1.0;
        float _928 = dot(_905.xyz, _875) * _893;
        float _935 = _891.z * _902;
        float _940 = _143._m4.w * _143._m5.w;
        float _946 = ((_386 * _46._m4.z) * _893) - _928;
        float _955 = (_891.x * 1.0) - _935;
        float _961 = sin(_946 - _955);
        float _966 = sin((_946 * 1.33000004291534423828125) - _955);
        float _972 = ((_961 + _966) * 0.25) + 0.5;
        _972 *= _972;
        float _981 = (_972 * (_885 - _882)) + _882;
        vec3 _989 = _875 * vec3(_981);
        float _994 = ((_891.y * 16.0) - _940) - _935;
        float _1002 = sin(((_386 * 4.0) * _896) + _994);
        float _1010 = cos(((_386 * 3.3299999237060546875) * _896) + _994);
        float _1018 = (_1002 + _1010) * (-_891.w);
        vec3 _1026 = vec3(_1002 * _888, _1010 * _888, _1018 * _899) * vec3(_981);
        vec3 _1040 = ((_989 + _1026) * _91._m0.z) * _891.z;
        vec3 _1053 = _905.xyz + _1040;
        _905 = vec4(_1053.x, _1053.y, _1053.z, _905.w);
        _905.w = 1.0;
        _829.x = dot(_905, _143._m12);
        _829.y = dot(_905, _143._m13);
        _829.z = dot(_905, _143._m14);
    }
    vec4 _1073 = _829;
    vec4 _1075 = _814;
    vec4 _1072;
    _1072.x = _12(_1073, _1075);
    vec4 _1079 = _829;
    vec4 _1081 = _817;
    _1072.y = _12(_1079, _1081);
    vec4 _1085 = _829;
    vec4 _1087 = _820;
    _1072.z = _12(_1085, _1087);
    vec4 _1091 = _829;
    vec4 _1093 = _823;
    _1072.w = _12(_1091, _1093);
    _1097 = _1072;
    gl_Position.y = -gl_Position.y;

  // Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}


