// Crosshair 2
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 1, binding = 0, std140) uniform _43_45
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
} _45;

layout(set = 0, binding = 0, std140) uniform _93_95
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
} _95;

layout(push_constant, std430) uniform _249_251
{
    int _m0;
    int _m1;
} _251;

layout(set = 2, binding = 1) uniform sampler2D _255;
layout(set = 2, binding = 2) uniform sampler2D _256;

layout(location = 0) in vec4 _158;
layout(location = 2) out vec4 _215;
layout(location = 1) in vec2 _217;
layout(location = 12) in vec2 _223;
layout(location = 0) out vec4 _229;
layout(location = 3) in vec4 _230;
layout(location = 3) out vec4 _232;
layout(location = 9) in vec4 _233;

mat4 _23(mat4 _21, mat4 _22)
{
    return _21 * _22;
}

float _16(vec4 _14, vec4 _15)
{
    return dot(_14, _15);
}

vec4 _11(vec4 _10)
{
    return clamp(_10, vec4(0.0), vec4(1.0));
}

void main()
{
    vec4 _131;
    vec4 _134;
    vec4 _137;
    vec4 _140;
    if (_45._m0.x > 0.0)
    {
        mat4 _57 = mat4(vec4(_45._m1), vec4(_45._m2), vec4(_45._m3), vec4(_45._m4));
        mat4 _92 = mat4(vec4(_95._m0), vec4(_95._m1), vec4(_95._m2), vec4(_95._m3));
        mat4 _126 = _57;
        mat4 _128 = _92;
        mat4 _125 = _23(_126, _128);
        _131 = _125[0];
        _134 = _125[1];
        _137 = _125[2];
        _140 = _125[3];
    }
    else
    {
        _131 = _45._m1;
        _134 = _45._m2;
        _137 = _45._m3;
        _140 = _45._m4;
    }
    vec4 _159 = _158;
    vec4 _161 = _131;
    gl_Position.x = _16(_159, _161);
    vec4 _166 = _158;
    vec4 _168 = _134;
    gl_Position.y = _16(_166, _168);
    vec4 _172 = _158;
    vec4 _174 = _137;
    gl_Position.z = _16(_172, _174);
    vec4 _179 = _158;
    vec4 _181 = _140;
    gl_Position.w = _16(_179, _181);
    vec2 _188 = _45._m5.xy;
    vec2 _193 = normalize(gl_Position.xy - _188);
    vec2 _211 = gl_Position.xy + (_193 * (_45._m5.w * _45._m5.z));
    gl_Position = vec4(_211.x, _211.y, gl_Position.z, gl_Position.w);
    _215 = vec4(_217.x, _217.y, _223.x, _223.y);
    _229 = _230;
    vec4 _238 = _233 * vec4(1.0039370059967041015625);
    _232 = (_11(_238) * vec4(2.0)) - vec4(1.0);
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
if(vk3d_params[VIEW].custom_params.y != 0)
{
    if((gl_Position.x < -0.2 || gl_Position.x > 0.2) || (gl_Position.y < -0.1 || gl_Position.y > 0.1))
        gl_Position.x += vk3d_params[VIEW].stereo.x * vk3d_params[VIEW].custom_params.x;
     else
	    gl_Position.x += vk3d_params[VIEW].stereo.x * vk3d_params[VIEW].custom_params.y; 
}
else
	gl_Position.x += vk3d_params[VIEW].stereo.x * vk3d_params[VIEW].custom_params.x; 
}





