// SCOPE 1
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 1, binding = 0, std140) uniform _49_51
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
} _51;

layout(set = 0, binding = 0, std140) uniform _88_90
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
} _90;

layout(set = 2, binding = 0, std140) uniform _151_153
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
} _153;

layout(set = 0, binding = 1, std430) restrict readonly buffer _223_225
{
    vec4 _m0[];
} _225;

layout(push_constant, std430) uniform _470_472
{
    int _m0;
    int _m1;
} _472;

layout(set = 2, binding = 1) uniform sampler2D _476;

layout(location = 0) in vec4 _142;
layout(location = 3) in vec4 _206;
layout(location = 9) in vec4 _243;
layout(location = 2) in vec4 _259;
layout(location = 1) in vec2 _419;
layout(location = 2) out vec4 _445;

mat4 _26(mat4 _24, mat4 _25)
{
    return _24 * _25;
}

float _12(vec4 _10, vec4 _11)
{
    return dot(_10, _11);
}

float _19(vec2 _17, vec4 _18)
{
    return dot(vec4(_17, 0.0, 1.0), _18);
}

void main()
{
    mat4 _48 = mat4(vec4(_51._m0), vec4(_51._m1), vec4(_51._m2), vec4(_51._m3));
    mat4 _87 = mat4(vec4(_90._m0), vec4(_90._m1), vec4(_90._m2), vec4(_90._m3));
    mat4 _121 = _48;
    mat4 _123 = _87;
    mat4 _120 = _26(_121, _123);
    vec4 _126 = _120[0];
    vec4 _129 = _120[1];
    vec4 _132 = _120[2];
    vec4 _135 = _120[3];
    vec3 _140 = _142.xyz;
    vec4 _145;
    _145.x = (_140.x * _153._m0.x) + _153._m1.x;
    _145.y = (_140.y * _153._m0.y) + _153._m1.y;
    _145.z = (_140.z * _153._m0.z) + _153._m1.z;
    _145.w = 1.0;
    if (_153._m2.z != 0.0)
    {
        vec4 _190 = _145;
        vec4 _192 = vec4(0.0);
        vec4 _194 = vec4(0.0);
        vec4 _195 = vec4(0.0);
        uvec4 _198 = uvec4(uint(_51._m4.x + _153._m2.x)) + uvec4(_206 * 255.0);
        if (_153._m2.z == 1.0)
        {
            uint _219 = _198.x;
            _192 = _225._m0[(_219 * 3u) + 0u];
            _194 = _225._m0[(_219 * 3u) + 1u];
            _195 = _225._m0[(_219 * 3u) + 2u];
        }
        else
        {
            float _242 = _243.w * 255.100006103515625;
            vec4 _249;
            _249.y = _242 - (floor(_242 / 128.0) * 128.0);
            float _258 = _259.w * 255.100006103515625;
            _249.z = floor(_258 / 16.0);
            _249.w = _258 - (_249.z * 16.0);
            _249.y *= 0.00393700785934925079345703125;
            _249.z *= 0.02222222276031970977783203125;
            _249.w *= 0.01666666753590106964111328125;
            _249.x = 1.0 - ((_249.y + _249.z) + _249.w);
            for (uint _299 = 0u; _299 < 4u; _299++)
            {
                _192 += (_225._m0[(_198[_299] * 3u) + 0u] * _249[_299]);
            }
            for (uint _323 = 0u; _323 < 4u; _323++)
            {
                _194 += (_225._m0[(_198[_323] * 3u) + 1u] * _249[_323]);
            }
            for (uint _346 = 0u; _346 < 4u; _346++)
            {
                _195 += (_225._m0[(_198[_346] * 3u) + 2u] * _249[_346]);
            }
        }
        vec4 _369 = _190;
        vec4 _371 = _192;
        _145.x = _12(_369, _371);
        vec4 _375 = _190;
        vec4 _377 = _194;
        _145.y = _12(_375, _377);
        vec4 _381 = _190;
        vec4 _383 = _195;
        _145.z = _12(_381, _383);
        _145.w = 1.0;
    }
    vec4 _392 = _145;
    vec4 _394 = _126;
    gl_Position.x = _12(_392, _394);
    vec4 _399 = _145;
    vec4 _401 = _129;
    gl_Position.y = _12(_399, _401);
    vec4 _405 = _145;
    vec4 _407 = _132;
    gl_Position.z = _12(_405, _407);
    vec4 _411 = _145;
    vec4 _413 = _135;
    gl_Position.w = _12(_411, _413);
    vec2 _417 = _419;
    vec4 _421;
    _421.x = (_417.x * _153._m3.x) + _153._m3.z;
    _421.y = (_417.y * _153._m3.y) + _153._m3.w;
    _421 = vec4(_421.x, _421.y, _421.xy.x, _421.xy.y);
    vec2 _446 = _421.xy;
    vec4 _449 = _153._m4;
    _445.x = _19(_446, _449);
    vec2 _455 = _421.xy;
    vec4 _458 = _153._m5;
    _445.y = _19(_455, _458);
    _445 = vec4(_445.x, _445.y, vec2(0.0).x, vec2(0.0).y);
    gl_Position.y = -gl_Position.y;

  // Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}


